dt=[-3.d0,-1.d0,1.d0,3.d0]/8.d0

openr,10,'bpogfiles'
file=' '

while not eof(10) do begin
   readf,10,file
   spawn,'cat '+strmid(file,1,15),str,count=n
   spawn,'cat '+file,bstr,count=bn
   reads,file,y,doy,format='(4x,i2,i3)'
   y=y+1900
   j=julday(1,doy,y)
   caldat,j,mo,dd,yy
   spawn,'cat mf-ogo-4-'+string(yy-1900,mo,dd,format='(3i2.2)')+'.txt',ogo,count=o
   str=str(22:n-1)
   bstr=bstr(22:bn-1)
   n=(n-22)/2
   bn=(bn-22)/2
   p=dblarr(3,n)
   t=dblarr(n)
   bp=dblarr(3,bn)
   bt=dblarr(bn)
   pos=dblarr(3)
   tim=intarr(5)
   s=0.d0

   for j=0L,n-1 do begin
      reads,str(2*j),tim,s,format='(3x,i4,4i3,f12.8)'
      t(j)=3600.d0*tim(3)+60.d0*tim(4)+s
      reads,str(2*j+1),pos,format='(4x,3f14.6)
      p(*,j)=pos
   endfor
   for j=0L,bn-1 do begin
      reads,bstr(2*j),tim,s,format='(3x,i4,4i3,f12.8)'
      bt(j)=3600.d0*tim(3)+60.d0*tim(4)+s
      reads,bstr(2*j+1),pos,format='(4x,3f14.6)
      bp(*,j)=pos
   endfor

   mat=dblarr(4,4)
   mat(0,0)=4
   mat(2,0)=total(dt^2)
   mat(1,1)=mat(2,0)
   mat(0,2)=mat(2,0)
   mat(3,1)=total(dt^4)
   mat(2,2)=mat(3,1)
   mat(1,3)=mat(3,1)
   mat(3,3)=total(dt^6)

   j=floor(4*t)-1
   k=j+3
   ret=where(j lt 0,nret)
   if(nret gt 0) then begin
      j(ret)=0
      k(ret)=3
   endif
   ret=where(k ge bn,nret)
   if(nret gt 0) then begin
      k(ret)=bn-1
      j(ret)=bn-4
   endif   

   vec=dblarr(3,4)
   c=dblarr(3,4)
   newp=dblarr(3,n)
   test=dblarr(3,n)

   for l=0L,n-1 do begin
      vec(*,0)=bp(*,j(l):k(l))#dt^0
      vec(*,1)=bp(*,j(l):k(l))#dt^1
      vec(*,2)=bp(*,j(l):k(l))#(dt^2)
      vec(*,3)=bp(*,j(l):k(l))#(dt^3)
      c=LA_LINEAR_EQUATION(mat,vec,/double)
      newp(*,l)=c(*,0)+c(*,1)*(t(l)-bt(j(l))-.375d0)+c(*,2)*(t(l)-bt(j(l))-.375d0)^2+c(*,3)*(t(l)-bt(j(l))-.375d0)^3
      test(*,l)=c(*,0)+c(*,1)*(-.375d0)+c(*,2)*(-.375d0)^2+c(*,3)*(-.375d0)^3
   endfor

   print,file,' ',max(abs(test-bp(*,j))),max(sqrt(total((p-newp)^2,1)))
   r=sqrt(total(newp^2,1))
   th=acos(newp(2,*)/r)*!radeg
   phi=atan(newp(1,*),newp(0,*))*!radeg
   opos=dblarr(3,n)
   openw,1,'mf-ogo-4-'+string(yy-1900,mo,dd,format='(3i2.2)')+'_fch.txt'
   for j=0,4 do printf,1,ogo(j)
   for j=0L,n-1 do begin
      reads,ogo(j+5),pos,format='(25x,f8.3,f11.5,f11.5)'
      opos(*,j)=pos
      og=ogo(j+5)
      strput,og,string(r(j),th(j),phi(j),format='(f8.3,f11.5,f11.5)'),25
      ogo(j+5)=og
      printf,1,ogo(j+5)
   endfor
   close,1
   openw,1,strmid(file,1,8)+'.dif'
   printf,1,[transpose(t),p,p-newp],format='(f11.5,6f11.4)'
   close,1
endwhile
close,/all
end
